export interface PackyakSpec {
    readonly modules: ModuleSpec[];
    readonly buckets: BucketSpec[];
    readonly queues: QueueSpec[];
    readonly functions: FunctionSpec[];
}
export interface FunctionSpec extends PythonPoetryArgs {
    readonly with: DependencyGroup | undefined;
    readonly without: DependencyGroup | undefined;
    readonly dev: boolean | undefined;
    readonly all_extras: boolean | undefined;
    readonly without_hashes: boolean | undefined;
    readonly without_urls: boolean | undefined;
    readonly function_id: string;
    readonly file_name: string;
    readonly bindings: BindingSpec[] | undefined;
}
export interface QueueSpec {
    readonly queue_id: string;
    readonly fifo: boolean;
    readonly subscriptions: QueueSubscriptionSpec[];
}
export interface QueueSubscriptionSpec {
    readonly function_id: string;
}
export interface BucketSpec {
    readonly bucket_id: string;
    readonly subscriptions: BucketSubscriptionSpec[];
}
export interface BucketSubscriptionSpec {
    readonly scopes: BucketSubscriptionScope[];
    readonly function_id: string;
}
export type BucketSubscriptionScope = "create" | "delete";
export interface ModuleSpec extends PythonPoetryArgs {
    readonly with: DependencyGroup | undefined;
    readonly without: DependencyGroup | undefined;
    readonly dev: boolean | undefined;
    readonly all_extras: boolean | undefined;
    readonly without_hashes: boolean | undefined;
    readonly without_urls: boolean | undefined;
    readonly file_name: string;
    readonly bindings: BindingSpec[] | undefined;
}
export interface PythonPoetryArgs {
    readonly with: DependencyGroup | undefined;
    readonly without: DependencyGroup | undefined;
    readonly dev: boolean | undefined;
    readonly all_extras: boolean | undefined;
    readonly without_hashes: boolean | undefined;
    readonly without_urls: boolean | undefined;
}
export interface BindingSpec {
    readonly resource_type: ResourceType;
    readonly resource_id: string;
    readonly scopes: string[];
    readonly props: Record<string, string> | undefined;
}
export type ResourceType = "bucket" | "queue" | "function";
export type DependencyGroup = [string, ...string[]] | string | undefined;
